
//+-------------------------------------------------------------------------------------------+
//|                                                                                           |
//|                                CCI Histogram                                              |
//|                                                                                           |
//+-------------------------------------------------------------------------------------------+ 
//Reference:  FX Sniper's CCI
#property copyright "Copyright  2006 FX Sniper"
#property link      "email:  fxsniper@gmail.com."
/*---------------------------------------------------------------------------------------------
"CCI Histogram" nodifications:

     Added Indicator On/Off bool at top of external inputs to allow the indicator to be 
turned off (not displayed), yet preserving settings for the chart.

     The indicator short name is changed to "CCI Histogram".  It now shows the CCI moving
average setting.  When the indicator is turned off, the short name will include a notation.
Indicator index levels are all set to NULL to keep the short name brief in indicator window. 

     Property indicator levels have been removed to keep right portion of indicator window 
clear for text from other indicator(s) also running in the window.

     Added "Suggested Settings" section to the compile.
                                                                              - Traderathome
------------------------------------------------------------------------------------------------
Suggested Settingss:            White Chart         Black Chart              

#property indicator_color1      C'132,170,240'      MediumBlue
#property indicator_color2      C'255,128,128'      C'115,87,60'
#property indicator_color3      Gray                Gray
#property indicator_color4      Yellow              Yellow
#property indicator_color5      DarkGray            Silver
#property indicator_color6      Red                 Red
#property indicator_color7      LimeGreen           LimeGreen

#property indicator_width1      2                   2
#property indicator_width2      2                   2
#property indicator_width3      2                   2
#property indicator_width4      5                   2
#property indicator_width5      4                   1
#property indicator_width6      2                   1
#property indicator_width7      2                   1

#property indicator_style1      STYLE_SOLID         STYLE_SOLID
#property indicator_style2      STYLE_SOLID         STYLE_SOLID
#property indicator_style3      STYLE_SOLID         STYLE_SOLID
#property indicator_style4      STYLE_SOLID         STYLE_SOLID
#property indicator_style5      STYLE_SOLID         STYLE_SOLID
#property indicator_style6      STYLE_SOLID         STYLE_SOLID 
#property indicator_style7      STYLE_SOLID         STYLE_SOLID

Enter_character_number          167                 158                                                               
----------------------------------------------------------------------------------------------*/                                         
#property indicator_separate_window

#property indicator_buffers     7
#property indicator_color1      C'132,170,240' 
#property indicator_color2      C'255,151,151' 
#property indicator_color3      Gray
#property indicator_color4      Yellow
#property indicator_color5      DarkGray
#property indicator_color6      Red
#property indicator_color7      LimeGreen

#property indicator_width1      2
#property indicator_width2      2
#property indicator_width3      2
#property indicator_width4      5
#property indicator_width5      4
#property indicator_width6      2
#property indicator_width7      2

#property indicator_style1      STYLE_SOLID
#property indicator_style2      STYLE_SOLID
#property indicator_style3      STYLE_SOLID
#property indicator_style4      STYLE_SOLID
#property indicator_style5      STYLE_SOLID
#property indicator_style6      STYLE_SOLID
#property indicator_style7      STYLE_SOLID

//global external inputs
extern bool   Indicator_On           = true;
extern int    CCI_Period             = 63;
extern string Baseline_characters    = "sml/lg sqr=158/167, dot=159";
extern int    Enter_character_number = 167;

//global buffers and variables
double        g_ibuf_84[];
double        g_ibuf_88[];
double        g_ibuf_92[];
double        g_ibuf_96[];
double        g_ibuf_100[];
double        g_ibuf_104[];
double        g_ibuf_108[];
int           g_count_120;
int           g_count_124;
int           gi_unused_128 = 0;

//+-------------------------------------------------------------------------------------------+
//| Program Initialization                                                                    |
//+-------------------------------------------------------------------------------------------+
int init() 
   {
   IndicatorBuffers(7);
   SetIndexStyle(4, DRAW_LINE);//Yellow
   SetIndexBuffer(4, g_ibuf_84);
   SetIndexLabel(4, "TrendCCI");
   SetIndexStyle(0, DRAW_HISTOGRAM);//Blue
   SetIndexBuffer(0, g_ibuf_88);
   SetIndexStyle(1, DRAW_HISTOGRAM);//Brown
   SetIndexBuffer(1, g_ibuf_92);
   SetIndexStyle(2, DRAW_HISTOGRAM);//Gray
   SetIndexBuffer(2, g_ibuf_96);
   SetIndexStyle(3, DRAW_HISTOGRAM);//Black
   SetIndexBuffer(3, g_ibuf_100);
   SetIndexStyle(5, DRAW_ARROW);
   SetIndexArrow(5, Enter_character_number);
   SetIndexBuffer(5, g_ibuf_104);
   SetIndexStyle(6, DRAW_ARROW);
   SetIndexArrow(6, Enter_character_number); //158=circle, 167=solid square
   SetIndexBuffer(6, g_ibuf_108);
      
   //---- Indicator Window name and data labels
   if(CCI_Period <= 0) {CCI_Period = 14;} 
   string short_name="CCI Histogram  ("+CCI_Period+")   ";
   if (Indicator_On == false)short_name=("CCI Histogram  ("+CCI_Period+")  -Indicator is off   ");
   IndicatorShortName(short_name);           
   SetIndexLabel(0, NULL);
   SetIndexLabel(1, NULL); 
   SetIndexLabel(2, NULL);
   SetIndexLabel(3, NULL);
   SetIndexLabel(4, NULL); 
   SetIndexLabel(5, NULL);
   SetIndexLabel(6, NULL);       
   return (0);
   }
    
//+-------------------------------------------------------------------------------------------+
//| Program De-initialization                                                                 |
//+-------------------------------------------------------------------------------------------+
int deinit() 
   {
   return (0);
   }

//+-------------------------------------------------------------------------------------------+
//| Program Start                                                                             |
//+-------------------------------------------------------------------------------------------+  
int start() {
   deinit(); if (Indicator_On == false) {return(0);}

   double ld_48;
   double ld_56;
   double ld_64;
   double ld_72;
   int l_day_0 = TimeDay(TimeCurrent());
   int l_month_4 = TimeMonth(TimeCurrent());
   int l_year_8 = TimeYear(TimeCurrent());
   int li_28 = IndicatorCounted();
   if (li_28 < 0) return (-1);
   if (li_28 > 0) li_28--;
   int l_bars_12 = Bars;
   int l_period_20 = CCI_Period;
   for (int l_bars_16 = l_bars_12; l_bars_16 >= 0; l_bars_16--) {
      g_ibuf_96[l_bars_16] = 0;
      g_ibuf_92[l_bars_16] = 0;
      g_ibuf_100[l_bars_16] = 0;
      g_ibuf_88[l_bars_16] = 0;
      g_ibuf_84[l_bars_16] = iCCI(NULL, 0, l_period_20, PRICE_TYPICAL, l_bars_16);
      if (g_ibuf_84[l_bars_16] > 0.0 && g_ibuf_84[l_bars_16 + 1] < 0.0)
         if (g_count_124 > 4) g_count_120 = 0;
      if (g_ibuf_84[l_bars_16] > 0.0) {
         if (g_count_120 < 5) {
            g_ibuf_96[l_bars_16] = g_ibuf_84[l_bars_16];
            g_count_120++;
         }
         if (g_count_120 == 5) {
            g_ibuf_100[l_bars_16] = g_ibuf_84[l_bars_16];
            g_count_120++;
         }
         if (g_count_120 > 5) g_ibuf_88[l_bars_16] = g_ibuf_84[l_bars_16];
      }
      if (g_ibuf_84[l_bars_16] < 0.0 && g_ibuf_84[l_bars_16 + 1] > 0.0)
         if (g_count_120 > 4) g_count_124 = 0;
      if (g_ibuf_84[l_bars_16] < 0.0) {
         if (g_count_124 < 5) {
            g_ibuf_96[l_bars_16] = g_ibuf_84[l_bars_16];
            g_count_124++;
         }
         if (g_count_124 == 5) {
            g_ibuf_100[l_bars_16] = g_ibuf_84[l_bars_16];
            g_count_124++;
         }
         if (g_count_124 > 5) g_ibuf_92[l_bars_16] = g_ibuf_84[l_bars_16];
      }
   }
   int li_32 = 25;
   int li_36 = Bars - li_32 - 5;
   int li_40 = li_36 - li_32 - 1;
   for (int li_44 = li_40; li_44 >= 0; li_44--) {
      ld_48 = 0;
      for (l_bars_16 = li_32; l_bars_16 >= 1; l_bars_16--) {
         ld_56 = li_32 + 1;
         ld_56 /= 3.0;
         ld_64 = 0;
         ld_64 = (l_bars_16 - ld_56) * (Close[li_32 - l_bars_16 + li_44]);
         ld_48 += ld_64;
      }
      ld_72 = 6.0 * ld_48 / (li_32 * (li_32 + 1));
      g_ibuf_104[li_44] = 0;
      g_ibuf_108[li_44] = 0;
      if (ld_72 > Close[li_44]) g_ibuf_108[li_44] = EMPTY_VALUE;
      else
         if (ld_72 < Close[li_44]) g_ibuf_104[li_44] = EMPTY_VALUE;
   }
   return (0);
}

//+-------------------------------------------------------------------------------------------+
//| Program End                                                                               |                                                        
//+-------------------------------------------------------------------------------------------+